from car_util import * # yeahhh don't do this

############
# Bonnet
############

def bonnet_pts(t):
    coolness_offset = 0.07
    # base of bonnet
    base = []
    for j, wd in enumerate([-wpoints[-1], -wpoints[1],
                             wpoints[1], wpoints[-1]]):
        p = []
        base.append(p)
        fl = copy(front_fwd)
        fl.reverse()
        for i, d in enumerate(fl):
            wid = wd
            if j == 0 or j == 3: # offset sides
                d += coolness_offset
            elif i == 1:
                d -= 0.1 # gives a better internal triangular setup
            elif i == 2:
                # XXX watch this one, it's very close to flipping on AUTO joint
                d += 0.09 # gives a better internal triangular setup
            if i in [1, 2]:
            # make room for generator
                if j == 1:
                    wid -= 0.10
                if j == 2:
                    wid += 0.10
            if i == 3 and (j == 0 or j == 3):
                continue
            if i == 3: # coolness factor #2, front points spaced out
                if j == 1:
                    wid = -wpoints[2]
                if j == 2:
                    wid = wpoints[2]
            if i in [0,1]: # increase bonnet width towards back
                if j == 0: # left back
                    wid -= 0.02
                if j == 3: # right back
                    wid += 0.02
            if i in [0]: # internal airbox
                if j == 1: # left back
                    wid -= 0.06
                if j == 2: # right back
                    wid += 0.06
            if i == len(fl)-1: # bring nose in slightly
                d += 0.07
            height = h1
            if i == 2: # lower front of bonnet slightly
                height -= 0.02
            pos = [wid, d, height]
            p.append(pos)
            t.add_joint(pos)

    # scoop
    scoop = []
    for i, wd in enumerate([-wpoints[1], wpoints[1]]):
        p = []
        scoop.append(p)
        for j, d in enumerate(fl[:-1]):
            height = h2 - 0.05
            woffs = 0
            if j == 0: # adjust back of bonnet scoop out and down (looks cool)
                woffs = 0.1 * (i - 0.5)
                height -= 0.02
            pos = [wd+woffs, d, height]
            p.append(pos)
            t.add_joint(pos)

    return [base, scoop]


class Bonnet(Group):
    def __init__(self):
        Group.__init__(self)
        self.dflt_pipe_diam = dthin

    def make(self):
        base, scoop = bonnet_pts(self)

        # horizontal pipes, front-wise
        for i in range(len(base[1])):
            p = base[i]
            for j in range(len(p)-1):
                offs1, offs2 = AUTO, AUTO
                diam = dthin
                if i in [0, len(base[1])-1]:
                    diam = dthick
                if j == 2:
                    diam = dthick
                    offs1, offs2 = jfwd, jback
                self.add_pipe(p[j], p[j+1], diam, offs1, offs2)

        # horizontal pipes, width-wise
        diam = dthin
        for i in range(len(base)-1):
            p = base[i]
            for j in range(len(base[0])):
                offs1, offs2 = AUTO, AUTO
                if j == 1:
                    if i == 0:
                        offs1 = jright
                    if i == len(base)-2:
                        #offs2 = jright
                        offs2 = jleft
                self.add_pipe(base[i][j], base[i+1][j], diam, offs1, offs2)

        # front
        p1, p2 = base[1][-1], base[2][-1]
        self.add_pipe(p1, p2, dthick)

        # horizontal pipes, diagonal-wise
        for j in range(len(base[0])-1):
            # left side
            self.add_pipe(base[0][j+1], base[1][j])
            # right side
            self.add_pipe(base[-1][j+1], base[-2][j])

        # front diagonals
        self.add_pipe(base[0][2], base[1][3], dthick, jrf, jleft)
        self.add_pipe(base[-1][2], base[-2][3], dthick, jlf, jright)

        # front horiz cross-diag
        for j in range(len(base)-1):
            self.add_pipe(base[1][j], base[2][j+1], dthin)

        # scoop pipes, width-wise
        for j in range(len(scoop[0])):
            offs1, offs2 = None, None
            if j != len(scoop[0])-1:
                diam = dthin
            else:
                diam = dthick
            self.add_pipe(scoop[0][j], scoop[1][j], diam)

        # scoop pipes, front-wise
        for j in range(len(scoop)):
            for i in range(len(scoop[0])-1):
                diam = dthin
                self.add_pipe(scoop[i][j], scoop[i][j+1], diam)

        # scoop pipes, horizontal, diagonal-wise
        for j in range(len(scoop[0])-1):
            # left side
            self.add_pipe(scoop[0][j], scoop[1][j+1], dthin)

        # scoop pipes, vertical
        for j in range(len(scoop[0])):
            for i in range(len(scoop)):
                self.add_pipe(scoop[i][j], base[i+1][j], dthin, jdown, jup)

        # scoop pipes, vertical-diagonal-forward
        for j in range(len(scoop[0])):
            for i in range(len(scoop)):
                offs1, offs2 = None, None
                if j != len(scoop[0])-1:
                    diam = dthin
                else:
                    diam = dthick
                self.add_pipe(scoop[i][j], base[i+1][j+1], diam)

        # scoop pipes, vertical-diagonal-forward
        for j in range(len(scoop[0])-1):
            for i in range(len(scoop)):
                offs1, offs2 = AUTO, AUTO
                if i == 0:
                    i2 = 0
                    offs1 = jlb
                    offs2 = jrfu3
                else:
                    i2 = -1
                    offs1 = jrb
                    offs2 = jlfu3
                self.add_pipe(scoop[i][j+1], base[i2][j], dthin, offs1, offs2)

        # scoop pipes, outwards-vertical
        for j in range(len(scoop[0])):
            for i in range(len(scoop)):
                offs1, offs2 = AUTO, AUTO
                if i == 0:
                    i2 = 0
                    if j == 0:
                        offs1 = jlfd3
                    offs2 = jur
                else:
                    i2 = -1
                    if j == 0:
                        offs1 = jrfd3
                    offs2 = jul
                self.add_pipe(scoop[i][j], base[i2][j], dthin, offs1, offs2)

        # add middle-front diagonal
        self.add_pipe(scoop[1][-1], base[1][-1], dthin, AUTO, AUTO)
        # add middle-middle diagonal
        self.add_pipe(scoop[0][1], base[2][1], dthin, AUTO, AUTO)

        return [base, scoop], self


